-- RWL --

Level = {}

Level.obstacles = {}
Level.gap = 130
Level.highest = 0
Level.cmdx = 0

function Level.draw()
	
	love.graphics.setColor(255,255,255)
	
	for f=0,resx/(144*2) do
		love.graphics.draw(Img.background,f*144*2,0,0,2,2)
	end
	
	for k,v in pairs(Level.obstacles) do
		love.graphics.draw(Img.pipe,getDrawX(v.x-Bird.x+26*3/2,-v.r,26*3,0),getDrawY(v.y-Level.gap/2-135*3,-v.r,26*3,0),-v.r,3,3)
		if v.y < resy - 210 - 80 then
			love.graphics.draw(Img.pipe,getDrawX(v.x-Bird.x+26*3/2,v.r,26*3,153*3),getDrawY(v.y+Level.gap/2+153*3/2,v.r,26*3,153*3),v.r,3,3)
		else
			love.graphics.draw(Img.pipe,getDrawX(v.x-Bird.x+26*3/2,0,26*3,153*3),getDrawY(v.y+Level.gap/2+153*3/2,0,26*3,153*3),0,3,3)
		end
	end
	
	if tractorBeam:isActive() then
		love.graphics.draw(tractorBeam)
	end
	
	if GUI.mode == "ship" then
		if love.timer.getTime() > GUI.shiptick + 6 then
			tractorBeamStart()
			love.graphics.draw(Img.bird[Bird.q],Bird.offX+12*3/2,Bird.y-17*3/2-math.min((love.timer.getTime()-GUI.shiptick-6)*100,resy/2),math.pi/2,3,3)
			if not Level.beamPlayed then
				sound.beam:play()
				Level.beamPlayed = true
			end
		end
		if love.timer.getTime() > GUI.shiptick + 3 then
			love.graphics.draw(Img.ship,Bird.offX-130,math.max(resy-(love.timer.getTime()-GUI.shiptick-3)*200,resy/2-Img.ship:getHeight()/2*12-26*2),0,12,12)
			if not Level.rumblePlayed then
				sound.rumble:play()
				Level.rumblePlayed = true
			end
		end
		if love.timer.getTime() > GUI.shiptick + 1.5 then
			love.graphics.draw(Img.cmdblock,Bird.offX+30+Level.cmdx-Bird.x,resy-56*2-Img.cmdblock:getHeight()*2,0,2,2)
			if not Level.cmdPlayed then
				sound.place:play()
				Level.cmdPlayed = true
			end
		end
	end
	
	for f=math.floor(Bird.x/(Img.ground:getWidth()*4)),resx/(Img.ground:getWidth()*4)+Bird.x/(Img.ground:getWidth()*4) do
		love.graphics.draw(Img.ground,f*Img.ground:getWidth()*4-Bird.x,resy-56*2,0,4,4)
	end
	
	if thruster:isActive() then
		love.graphics.draw(thruster)
		love.graphics.draw(thruster2)
	end
	
	-- love.graphics.print("Obstacles: "..#Level.obstacles,10,10)
	
end

function Level.update(dt)
	
	if GUI.mode == "game" or GUI.mode == "ship" then
		for k,v in pairs (Level.obstacles) do
			if v.x < Bird.x - Bird.offX - 26*3 - 100 then
				table.remove(Level.obstacles,k)
			end
		end
		if #Level.obstacles < 7 then
			Level.GenerateObstacle()
		end
	end
	
	if thruster:isActive() then
		thruster:update(dt)
		thruster2:update(dt)
	end
	
	if tractorBeam:isActive() then
		tractorBeam:update(dt)
		if love.timer.getTime() > GUI.shiptick + 8 then
			tractorBeam:stop()
		end
	end

end

function Level.GenerateObstacle()
	table.insert(Level.obstacles,{x=(Level.highest+1)*26*3*3+300,y=math.random(210,resy-210),r=0})
	if GUI.mode == "ship" then
		Level.highest = Level.highest + 1.1
	else
		Level.highest = Level.highest + 1
	end
end

function Level.reset()
	Bird.y = resy/2-56
	Bird.alive = true
	Bird.lastPoint = 0
	Bird.shipv = 0
	GUI.dietick = 0
	GUI.menutick = 0
	GUI.newscore = false
	Level.obstacles = {}
	Level.cmdPlayed = false
	Level.beamPlayed = false
	Level.rumblePlayed = false
	Settings.score = 0
	GUI.dimtick = love.timer.getTime()
	ThrustersStop()
	for k,v in pairs (sound) do
		if k ~= "click" then
			v:stop()
		end
	end
end