-- Flappy Bling --

resx = 900
resy = 600

require "settings"
require "graphics"
require "sound"
require "GUI"
require "bird"
require "level"
require "particles"

love.window.setTitle("Flappy Bling")
love.window.setMode(resx,resy)
love.window.setIcon(love.image.newImageData("graphics/icon.png"))

math.randomseed(os.clock())

function love.draw()
	if GUI.mode ~= "splash" then
		Level.draw()
		Bird.draw()
	end
	GUI.draw()
end

function love.update(dt)
	if GUI.mode ~= "pause" then
		Bird.update(dt)
		Level.update(dt)
	end
end

function love.keypressed(k)
	GUI.keypressed(k)
	if k == "f2" then
		love.graphics.newScreenshot():encode("screenshot.png")
	end
end

function love.mousepressed(x,y,b)
	if b == "l" then
		GUI.mousepressed(x,y)
	end
end

function love.quit()
	Settings.save()
end

opentick = love.timer.getTime()